package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.DataAudit;
import com.sa.ibiz.demo.demo.service.DataAuditService;
import com.sa.ibiz.demo.demo.service.dto.DataAuditSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/dataaudit")
public class DataAuditResource
{
	@Autowired
	private DataAuditService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<DataAudit> checkKey(@Validated @RequestBody DataAudit data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("数据审计[checkKey]操作发生错误","DataAudit",data.getDataauditid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<DataAudit> get(@Validated @PathVariable String id){
		DataAudit data=new DataAudit();
		data.setDataauditid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("数据审计[get]操作发生错误","DataAudit",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<DataAudit> create(@Validated @RequestBody DataAudit data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("数据审计[create]操作发生错误","DataAudit",data.getDataauditid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<DataAudit> update(@Validated @RequestBody DataAudit data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("数据审计[update]操作发生错误","DataAudit",data.getDataauditid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<DataAudit> getDraft(@Validated @RequestBody DataAudit data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("数据审计[getDraft]操作发生错误","DataAudit","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<DataAudit> remove(@Validated @RequestBody DataAudit data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("数据审计[remove]操作发生错误","DataAudit",data.getDataauditid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<DataAudit>> searchDefaultPage(@Validated @RequestBody DataAuditSearchFilter filter){
		Page<DataAudit> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<DataAudit>> listDefault(@Validated @RequestBody DataAuditSearchFilter filter){
		List<DataAudit> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
